#include <hmg.ch>

Function fontsizewidth()
  MEMVAR _HMG_SYSDATA
  
  DEFINE WINDOW Form_Main ;
      AT 0,0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      MAIN;
      TITLE 'FontSizeWidth on Test'

      DEFINE BUTTON Button_1 
        ROW 50 
        COL 50 
        CAPTION "FontSizeWidth" 
        ONCLICK TestFontSizeWidth() 
        WIDTH 100 
        HEIGHT 30
      END BUTTON  
      
  END WINDOW

  Form_Main.Center
  Form_Main.Activate

Return NIL

FUNCTION TestFontSizeWidth()
  LOCAL aFont, aFontSize, aText, aFontName
  LOCAL cFontName, cText, cText1, cNum
  LOCAL nFontSize, nOneInch, nPAWidth, nPAHeight, nPAHorOffset, nPAVerOffset, nI
  LOCAL nRow1, nRow2, nCol1, nCol2, nRow, nCol, nOneCm, nPrintLen, nJ
  LOCAL nVSpace, nMyPrintLen, nC
  LOCAL lSuccess
  MEMVAR _HMG_SYSDATA
  
  aText := {  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789", ;
              "abcdefghijklmnopqrstuvwxyz0123456789", ;
							"To Be or Not To Be, Thats The Question !"}
  aText2 := { "人的一生，平安就好。", ;
              hb_UChar( 0x250C) + Replicate( hb_UChar ( 0x2500),20) + hb_UChar( 0x2510), ;
              hb_UChar( 0x2502) + "12345678901234567890" + hb_UChar( 0x2502)}
  
	aFontSize := { 07, 08, 09, 10, 12, 14, 16, 18}
  
  aFontname := { "CONSOLAS", "LUCIDA CONSOLE", "ARIAL", "ARIAL NARROW", "COURIER", "TIMES NEW ROMAN"}

  SELECT PRINTER DIALOG TO lSuccess PREVIEW

  IF lSuccess
    nOneInch := 25.4
    nOneCm   := 10
    nPAWidth     := GetPrintableAreaWidth()
		nPAHeight    := GetPrintableAreaHeight()
		nPAHorOffset := GetPrintableAreaHorizontalOffset()
		nPAVerOffset := GetPrintableAreaVerticalOffset()
    
    START PRINTDOC
		  FOR nFont := 1 TO LEN( aFontname)
			  cFontName := aFontName[ nFont]
      START PRINTPAGE
				*- draw cm block
        CmBlock( nPAWidth, nPAHeight)
                
        nRow := 0
        nCol := 0
        nVSpace := 5
  
				@ nRow+5, nCol PRINT "Fontname  : " + cFontName
				@ nRow+9, nCol PRINT "The Red line is PrintLen width." COLOR RED
				

				nRow := 10
        FOR nI := 1 TO LEN( aFontSize)
          nFontSize := aFontSize[ nI] && in pixel 
          nVSpace   := nFontSize / 2 + 1
          
          FOR nJ := 1 TO LEN( aText)
            cText := aText[ nJ]
            cText2 := aText2[ nJ]
            nRow += nVSpace + 3
            nCol := 0
            nCol2 := 100
            if nRow > nPAHeight
						  EXIT
						ENDIF
            PrintSample( nRow, nCol, cText, cFontName, nFontSize, nVSpace)
            *- PrintSample( nRow, nCol2, cText2, cFontName, nFontSize, nVSpace)
            
          NEXT 
        NEXT
      END PRINTPAGE
			
			NEXT && nFont
    END PRINTDOC
  ENDIF
  
  RETURN NIL
  
FUNCTION PrintSample( nRow, nCol, cText, cFontName, nFontSize, nVSpace)
  LOCAL cText1
  LOCAL nPrintLen, nMyPrintLen

  cText1 := cText + PADL( nFontSize, 3)
  @ nRow, nCol PRINT cText1 FONT cFontName SIZE nFontSize
            
  nPrintLen := RPrintLen2( cText, nFontSize, cFontName)
	nRow1 := nRow 
	nRow2 := nRow + nVSpace
	nCol1 := nCol2 := nPrintLen
	@ nRow1, nCol1 PRINT LINE TO nRow2, nCol2 PENWIDTH 0.01 COLOR RED
  RETURN NIL  

function RprintLen2( cString, nFontsize, cFontname)
  cCreateFont := _HMG_CREATEFONT( OpenPrinterGetDC(), cFontname, nFontSize )
  nGetTextWidth := gettextwidth( OpenPrinterGetDC(), cString, cCreateFont )
	nWidth := nGetTextWidth * 25.4 / 600
	RETURN( ROUND( nWidth, 2))
	*- return round( nGetTextWidth * 0.0254 * nFontsize, 2 ) 
	

#pragma BEGINDUMP

#include "SET_COMPILE_HMG_UNICODE.ch"

#ifndef COMPILE_HMG_UNICODE
   #define COMPILE_HMG_UNICODE   // Force to compile in UNICODE
#endif

#include "HMG_UNICODE.h"

#include <windows.h>
#include "hbapi.h"

HB_FUNC ( _HMG_CREATEFONT )
 
{
   HFONT hFont ;
   int bold = FW_NORMAL;
   int italic = 0;
   int underline = 0;
   int strikeout = 0;

   if ( hb_parl (4) )
      bold = FW_BOLD;

   if ( hb_parl (5) )
      italic = 1;

   if ( hb_parl (6) )
      underline = 1;

   if ( hb_parl (7) )
      strikeout = 1;

   HDC hDC = (HDC) HMG_parnl (1);
   TCHAR *FontName = (TCHAR *) HMG_parc (2);
   INT FontSize = hb_parni (3);

   SetGraphicsMode (hDC, GM_ADVANCED);

   FontSize = FontSize * GetDeviceCaps (hDC, LOGPIXELSY) / 72;   // Size of font in logic points

   hFont = CreateFont (0-FontSize, 0, 0, 0, bold, italic, underline, strikeout,
           DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, FontName);

   HMG_retnl ((LONG_PTR) hFont );
}

#pragma enddump  
  
    
FUNCTION CmBlock( nPAWidth, nPAHeight)    
  LOCAL cNum
  LOCAL nOneCm, nOneInch
  LOCAL nI, nRow, nRow1, nRow2, nCol, nCol1, nCol2
  MEMVAR _HMG_SYSDATA
  
  nOneCm := 10
  nOneInch := 25.4
	nTwoMm := 5
  
  *- Vertical Line
  nI := 0
  DO WHILE nI < nPAWidth
	  * 2mm V-Line
    *- IF MOD( nI, nTwoMm) == 0
    *-   nRow1 := 0
    *-   nRow2 := nPaHeight
    *-   nCol1 := nCol2 := nI
    *-   @ nRow1, nCol1 PRINT LINE TO nRow2, nCol2 PENWIDTH 0.01 COLOR SILVER
    *- ENDIF
		
    * cm V-Line
    IF MOD( nI, nOneCm) == 0
      nRow1 := 0
      nRow2 := nPaHeight
      nCol1 := nCol2 := nI
      @ nRow1, nCol1 PRINT LINE TO nRow2, nCol2 PENWIDTH 0.03 COLOR AQUA
      
      cNum := nI && ALLTRIM( STR( INT( MOD( nI, 110))))
      @ 0, nCol1 PRINT cNum FONT "CONSOLAS" SIZE 10
      @ nPAHeight - 5, nCol2 PRINT cNum FONT "CONSOLAS" SIZE 10
    ENDIF
    
    * Inch V-Line
    IF MOD( nI, nOneInch) == 0
      nRow1 := 0
      nRow2 := nPaHeight
      nCol1 := nCol2 := nI
      *- @ nRow1, nCol1 PRINT LINE TO nRow2, nCol2 PENWIDTH 0.05 COLOR SILVER
    ENDIF
		
		
    
    nI++
  ENDDO
  
  *- Horizonal Line
  nI := 0
  DO WHILE nI < nPAHeight 
    IF MOD( nI, nOneCm) == 0
      nRow1 := nRow2 := nI
      nCol1 := 0
      nCol2 := nPAWidth
      @ nRow1, nCol1 PRINT LINE TO nRow2, nCol2 PENWIDTH 0.05 COLOR AQUA
    ENDIF
    nI++
  ENDDO

  RETURN NIL
  
/*
  aConsolas := { {  5,  26,  26}, ;
                 {  6,  22,  22
                 {  7,  19,  19
                 {  8,  16,  16
                 {  9,  15,  15
                 { 10, 13 , 13
                 { 11, 12 , 12
                 { 12, 11 , 11
                 { 13, 10 , 10
                 { 14, 9.5, 9.5
                 { 15,  9 ,  9
                 { 16,  8 ,  8
                 sama
                 
  aCourier := { { 5, 26                  
                { 6, 21    
                { 7, 19    
                { 8, 16    
                { 9, 14    
              { 10,13 
                { 11, 12 
                { 12, 11
                { 13, 10
                { 14, 09
                { 15, 09
                { 16, 08
                sama
                
  Times New Roman { { 5,  29
                    { 6,  24
                    { 7,  21
                    { 8,  18
                    { 9,  16
                    { 10, 14
                    { 11, 13
                    { 12, 12
                    { 13, 11
                    { 14, 10
                    { 15, 9.5
                    { 16, 09
                    sama

  Arial := { { 5, 32                     
                 { 6,  26
                 { 7,  23
                 { 8,  19.5
                 { 9,  18
                 { 10, 16
                 { 11, 14
                 { 12, 13
                 { 13, 12
                 { 14, 11.5
                 { 15, 11
                 { 16, 10
                 sama
                 
  Verdana := { { 5,  22, 20
               { 6,  19, 17
               { 7,  16, 15
               { 8,  14, 13
               { 9,  13, 12
               { 10, 11.5, 10
               { 11, 10, 09
               { 12, 9.5, 8.5
               { 13, 09, 08
               { 14, 08, 07
               { 15, 7.5, 07 
               { 16, 7, 6  
               
*/               

*- function RprintLen1( cString, nFontsize, cFontname)
*- 	LOCAL nWidth
*-   nWidth := round(gettextwidth( Nil,cString,cFontname)*0.0254*nFontsize,2)
*- 	nWidth := gettextwidth( Nil,cString,cFontname)*0.0254*nFontsize
*- 	
*- 	nLen := LEN( cString)
*- 	DO CASE
*- 	  CASE UPPER( cFontname) == UPPER( "Arial")
*- 		  DO CASE
*- 			  CASE UPPER( cString) == cString
*- 				  nRatio := 0
*- 				CASE LOWER( cString) == cString	
*- 				  nRatio := .4
*- 				OTHERWISE
*- 					nRatio := 0
*- 			ENDCASE
*- 		  nWidth := nWidth - nFontSize * nRatio
*- 	  CASE UPPER( cFontname) == UPPER( "Arial Narrow")
*- 		  DO CASE
*- 			  CASE UPPER( cString) == cString
*- 				  nRatio := 0.7
*- 				CASE LOWER( cString) == cString	
*- 				  nRatio := .8
*- 				OTHERWISE
*- 					nRatio := .78  && .8
*- 				  *- msgDebug( nLen, nWidth, nFontSize, nFontSize * nLen/nWidth)
*- 			ENDCASE
*- 		  *- nRatio := IIF( UPPER( cString) == cString, 1.4, 1.6)
*- 		  nWidth := nWidth - nFontSize * nRatio
*- 	ENDCASE
*- 	RETURN( ROUND( nWidth, 2))

*-FUNCTION MyPrintLen( cString, nFontSize, cFontName)
*-  LOCAL nFontWidth, nRatio
*-  DO CASE
*-    CASE UPPER( cFontName)== "CONSOLAS"
*-      nRatio := .554
*-    CASE UPPER( cFontName) == "LUCIDA CONSOLE"
*-      nRatio := .6
*-    CASE UPPER( cFontName) == "ARIAL"  
*-      nRatio := .65
*-    CASE UPPER( cFontName) == "COURIER"  
*-      nRatio := .65  
*-    CASE UPPER( cFontName) == "TIMES NEW ROMAN"  
*-      nRatio := .62   
*-    OTHERWISE
*-      nRatio := 0
*-  ENDCASE
*-  nFontWidth := nFontSize * nRatio
*-  RETURN( LEN( cString) * nFontWidth * 25.4 / 72.272)
